MainDlgProc proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

	mov	eax,uMsg
	.if eax==WM_INITDIALOG
		push hWin
		pop hMain
		
	.elseif eax==WM_COMMAND
		mov edx,wParam
		movzx eax,dx
		shr edx,16
		.if edx==BN_CLICKED
			.if eax==IDC_BTN1
				invoke CreateEventsAndThreads
				invoke TriggerFunction
			.endif
		.endif
	.elseif eax==WM_CLOSE
		invoke EndDialog,hWin,0
	.else
		mov eax,FALSE
		ret
	.endif
	mov eax,TRUE
	ret

MainDlgProc endp

CreateEventsAndThreads proc
	LOCAL ThreadID:dword
	
	mov edi,offset hEvents
	
	invoke CreateEvent,0,TRUE,FALSE,0
	mov hEvent1,eax
	mov dword ptr [edi],eax
	
	invoke CreateEvent,0,TRUE,FALSE,0
	mov hEvent2,eax
	mov dword ptr [edi+4],eax
	
	invoke CreateEvent,0,TRUE,FALSE,0
	mov hEvent3,eax
	mov dword ptr [edi+8],eax
	
	invoke CreateThread,0,0,offset ThreadFunction,hEvent1,0,addr ThreadID
	invoke CreateThread,0,0,offset ThreadFunction,hEvent2,0,addr ThreadID
	invoke CreateThread,0,0,offset ThreadFunction,hEvent3,0,addr ThreadID
	
	ret
CreateEventsAndThreads endp

ThreadFunction proc lParam:dword
	LOCAL buffer[256]:byte
	
	mov edi,lParam
	
	invoke WaitForMultipleObjects,3,offset hEvents,FALSE,INFINITE
	.if eax==0
		invoke ResetEvent,hEvent1
		xor ecx,ecx
		.while ecx<1000
			push ecx
			invoke wsprintf,addr buffer,ASTR("%d"),ecx
			invoke SetWindowText,hMain,addr buffer
			pop ecx
			inc ecx
		.endw
		invoke SetDlgItemText,hMain,1002,ASTR("hEvent1")
		
	.elseif eax==1
		invoke ResetEvent,hEvent2
		.while ecx<1000
			push ecx
			invoke wsprintf,addr buffer,ASTR("%d"),ecx
			invoke SetWindowText,hMain,addr buffer
			pop ecx
			inc ecx
		.endw
		invoke SetDlgItemText,hMain,1003,ASTR("hEvent2")
		
	.elseif eax==2
		.while ecx<1000
			push ecx
			invoke wsprintf,addr buffer,ASTR("%d"),ecx
			invoke SetWindowText,hMain,addr buffer
			pop ecx
			inc ecx
		.endw
		invoke SetDlgItemText,hMain,1004,ASTR("hEvent3")
		
	.endif

	ret
ThreadFunction endp

TriggerFunction proc
	LOCAL buffer[256]:byte
	
	mov ecx,10000
	.while sdword ptr ecx>0
		push ecx
		invoke SetDlgItemInt,hMain,1002,ecx,TRUE 
		pop ecx
		dec ecx
	.endw
	invoke SetEvent,hEvent1
	
	mov ecx,10000
	.while sdword ptr ecx>0
		push ecx
		invoke SetDlgItemInt,hMain,1003,ecx,TRUE 
		pop ecx
		dec ecx
	.endw
	invoke SetEvent,hEvent2
	
	mov ecx,10000
	.while sdword ptr ecx>0
		push ecx
		invoke SetDlgItemInt,hMain,1004,ecx,TRUE 
		pop ecx
		dec ecx
	.endw
	invoke SetEvent,hEvent3
	
	ret

TriggerFunction endp